/**
 * Clase Cuenta
 * @author Sergio Blanco Cuaresma
 * @author Jonathan Hernndez Velasco
*/
 
public abstract class Cuenta {
	protected int Saldo;
	protected double Interes;
	protected Cliente Titular;
	protected int Comision;
	
/**
 * Constructor
 * @param Titular Titular de la Cuenta 
 * @param Saldo Saldo que tiene la Cuenta
*/
  
  Cuenta(Cliente Titular, int Saldo){
    this.Titular = Titular;
		this.Saldo = Saldo;
		this.Comision = 100;
  }
  
/**
 * Establecer Titular
 * @param Titular Titular de la Cuenta
*/  
	public void setTitular (Cliente Titular){
		this.Titular = Titular;
	}

/**
 * Consulta Titular
 * @return Devuelve el titular de la cuenta
*/  
  public Cliente getTitular () {
    return this.Titular;
  }

/**
 * Hace la Revisin de la cuenta. Al incremento dado por el interes se le resta la comisin
*/	 
	public void revision () {
	  this.Saldo = Saldo +  (int)(Saldo*Interes - Comision);
	}

/**
 * Consulta Saldo
 * @return Devuelve el saldo actual de la cuenta
*/	 
	public int getSaldo () {
		return this.Saldo;
	}

/**
 * Establece una comision para la cuenta
*/
  public void setComision (int c) {
    this.Comision = c;
  }

/**
 * Consulta Comision
 * @return Devuelve la comision actual de la cuenta
*/	 
  public int getComision (){
    return this.Comision;
  }
	
/**
 *  Ingresar una cantidad de dinero en la cuenta
 * @param cantidad Cantidad de dinero a ingresar
*/  
  public void ingresar (int cantidad){
    this.Saldo = Saldo + cantidad;
  }
  
	public abstract void retirar (int cantidad) throws CuentaBloqueadaException, SinSaldoException, OpNoPermitidaException;
	
}
