/**
 * Clase FondosInversion que implementa la Clase Cuenta
 * @author Sergio Blanco Cuaresma
 * @author Jonathan Hernndez Velasco
 */

public class FondosInversion extends Cuenta {

/**
 * Constructor
 * @param Titular Titular de la Cuenta 
 * @param Saldo Saldo que tiene la Cuenta
*/  
  FondosInversion(Cliente Titular, int Saldo){
    super(Titular, Saldo);
		this.Interes = 0.3;
  }
  
  /**
  * Extrae de la cuenta una cantidad de dinero.
  * @param cantidad Cantidad a extraer de la cuenta
  * @throws CuentaBloqueadaException  Excepcin que salta cuando la cuenta ha llegado a su mximo de numeros rojos
  * @throws SinSaldoException Excepcin que salta cuando se intenta sacar ms cantidad de la que hay
  */
  
	public void retirar (int cantidad) throws CuentaBloqueadaException, SinSaldoException {
    if (Saldo==-100000){
      throw new CuentaBloqueadaException();
    }
    else{
      if (Saldo - cantidad >= -100000){
        this.Saldo = Saldo - cantidad;
      }
      else{
        throw new SinSaldoException();
      }
    }
  }
  
  /**
  * Refinamiento de la revision. Si esta en numeros rojos se quita ademas Saldo*0.2
  */
  public void revision () {
    super.revision();
    if (Saldo < 0) {
	  	this.Saldo = Saldo + (int)(Saldo*0.2);
	  }
	}
  
}
