/**
 * Fichero de Prueba Test.java
 * @author Sergio Blanco Cuaresma
 * @author Jonathan Hernndez Velasco
*/

import java.util.Iterator;
import java.util.LinkedList;

class Test {

public static void main(String args[]) throws CuentaBloqueadaException, SinSaldoException, OpNoPermitidaException {
  
  //creacin de un banco
  Banco b = new Banco();
  
  //creacin de unos clientes ficticios
  Cliente c1 = new Cliente("47763321-A", "Juanito", "Perez Lopez", "Calle Balmes 22 2ndo 3ero",977554433);
  Cliente c2 = new Cliente("47763322-B", "Pepe", "Agua Azul", "Calle Biruel 34 1er",977212334);
  Cliente c3 = new Cliente("47763323-C", "Luis", "Inde Ande", "Calle Jennia 345 puerta 2 3o 1a",916545678);
  Cliente c4 = new Cliente("47763324-D", "Pedro", "Uala Miala", "Calle Juarjo 232",935667878);
  Cliente c5 = new Cliente("47763325-E", "Pablo", "Hur Murning", "Calle Pitalindo 2ndo",977633533);
  
  //aadimos al banco los clientes
  b.insertarCliente(c1); 
  b.insertarCliente(c2);
  b.insertarCliente(c3);
  b.insertarCliente(c4);
  b.insertarCliente(c5);
  
  //creamos unas cuentas ficticias de los 3 tipos repartidas para los clientes
  Cuenta cu1 = new CuentaCorriente(c1, 100000);
  Cuenta cu2 = new FondosInversion(c1, 500000);
  Cuenta cu3 = new CuentaCorriente(c2, 1000000);
  Cuenta cu4 = new CuentaVivienda(c2, 750000);
  Cuenta cu5 = new CuentaCorriente(c3, 455000);
  Cuenta cu6 = new CuentaVivienda(c3, 600000);
  Cuenta cu7 = new CuentaVivienda(c4, 877660);
  Cuenta cu8 = new FondosInversion(c4, 1200150);
  Cuenta cu9 = new FondosInversion(c5, 2500000);
  
  //aadimos dichas cuentas al banco
  b.insertarCuenta(cu1);
  b.insertarCuenta(cu2);
  b.insertarCuenta(cu3);
  b.insertarCuenta(cu4);
  b.insertarCuenta(cu5);
  b.insertarCuenta(cu6);
  b.insertarCuenta(cu7);
  b.insertarCuenta(cu8);
  b.insertarCuenta(cu9);
  
  //primera prueba: Utilizar el mtodo listadoClientes de la clase Banco y mostrar por pantalla los resultados
  LinkedList listado = new LinkedList();
  listado = b.listadoClientes();
  Iterator it = listado.iterator();
  
  System.out.println("Inicio DNIs de los Clientes:");
  while (it.hasNext()){
    String s = (String)it.next();
    System.out.println(s); 
  }
  System.out.println("Fin DNIs de los Clientes:");
  
  //comprobacin de la classe cliente con el cliente c1:
  
  System.out.println("Inicio Todos los datos del cliente c1");
  System.out.println(c1.getDNI());
  System.out.println(c1.getNombre());
  System.out.println(c1.getApellidos());
  System.out.println(c1.getDireccion());
  System.out.println(c1.getTelefono());
  System.out.println("Fin Todos los datos del cliente c1");
  
  //comprobacion de la classe cuenta y sus derivadas:
  
  //cuenta corriente:
  System.out.println("----Cuenta Corriente----");
  System.out.println(cu1.getSaldo());
        //ejemplo de revision
  cu1.revision();
  System.out.println(cu1.getSaldo());
        //ejemplo de ingreso
  cu1.ingresar(125000);
  System.out.println(cu1.getSaldo());
  try{
        //retornar SinSaldoException
    cu1.retirar(4500000);
  } catch (CuentaBloqueadaException e1) {
  } catch (SinSaldoException e2) {
  } catch (OpNoPermitidaException e3) {
  }
  System.out.println(cu1.getSaldo());
  
  //fondo inversion:
  System.out.println("----Fondo Inversin----");
  System.out.println(cu8.getSaldo());
  try{
        //retiramos todo el dinero
    cu8.retirar(1200150); 
  } catch (CuentaBloqueadaException e1) {
  } catch (SinSaldoException e2) {
  } catch (OpNoPermitidaException e3) {
  }
  System.out.println(cu8.getSaldo());
        //ejemplo de revision sin numeros rojos
  cu8.revision(); 
  System.out.println(cu8.getSaldo());
  try{
      //retiramos 50000, nos quedamos en numeros rojos
    cu8.retirar(50000);
  } catch (CuentaBloqueadaException e1) {
  } catch (SinSaldoException e2) {
  } catch (OpNoPermitidaException e3) {
  }
  System.out.println(cu8.getSaldo());
        //ejemplo de revision en numeros rojos, aumenta la cantidad restada
  cu8.revision();
  System.out.println(cu8.getSaldo());
  try{
        //retiramos 1pta mas del maximo de -100000 que tiene el fondoinversion, salta SinSaldoException
    cu8.retirar(47837);
  } catch (CuentaBloqueadaException e1) {
  } catch (SinSaldoException e2) {
  } catch (OpNoPermitidaException e3) {
  }
  System.out.println(cu8.getSaldo());
  try{
        //retiramos la cantidad exacta para quedarnos a -100000
    cu8.retirar(47836);
  } catch (CuentaBloqueadaException e1) {
  } catch (SinSaldoException e2) {
  } catch (OpNoPermitidaException e3) {
  }
  System.out.println(cu8.getSaldo());
  try{
        //intentamos retirar 1pta de ms del limite de 100000, pero la cuenta ya ha sido bloqueada por llegar al max, salta CuentaBloqueadaException.
    cu8.retirar(1);
  } catch (CuentaBloqueadaException e1) {
  } catch (SinSaldoException e2) {
  } catch (OpNoPermitidaException e3) {
  }
  System.out.println(cu8.getSaldo());
        //ejemplo de revision con el mximo de numeros rojos
  cu8.revision();
  System.out.println(cu8.getSaldo());
  
  //cuenta vivienda:
  System.out.println("----Cuenta Vivienda----");
  System.out.println(cu4.getSaldo());
        //ejemplo de revision
  cu4.revision();
  System.out.println(cu4.getSaldo());
        //ejemplo de ingreso
  cu4.ingresar(125000);
  System.out.println(cu4.getSaldo());
  try{
        //ejemplo de extracto, como en una CuentaVivienda no se puede extraer, saltar OpNoPermitidaException
    cu4.retirar(45000);
  } catch (CuentaBloqueadaException e1) {
  } catch (SinSaldoException e2) {
  } catch (OpNoPermitidaException e3) {
  }
  System.out.println(cu4.getSaldo());
  
  //Ahora haremos una revisin completa de todas las cuentas del banco:
 System.out.println("*****Inicio Revision Global Cuentas*****");
 System.out.println("Sin revision");
        //primero listamos los saldos de todas las cuentas:
 System.out.println(cu1.getSaldo());
 System.out.println(cu2.getSaldo());
 System.out.println(cu3.getSaldo());
 System.out.println(cu4.getSaldo());
 System.out.println(cu5.getSaldo());
 System.out.println(cu6.getSaldo());
 System.out.println(cu7.getSaldo());
 System.out.println(cu8.getSaldo());
 System.out.println(cu9.getSaldo());
        //efectuamos la revision global
  b.revision();
  System.out.println("Con revision");
        //listamos todas las cuentas actualizadas
 System.out.println(cu1.getSaldo());
 System.out.println(cu2.getSaldo());
 System.out.println(cu3.getSaldo());
 System.out.println(cu4.getSaldo());
 System.out.println(cu5.getSaldo());
 System.out.println(cu6.getSaldo());
 System.out.println(cu7.getSaldo());
 System.out.println(cu8.getSaldo());
 System.out.println(cu9.getSaldo());
 System.out.println("*****Fin Revision Global Cuentas*****"); 
  
  // Parte Opcional: Ordenacin de Cuentas:
        //inicializacion de las vars. que vamos a utilizar
  Object[] CuentasArray;
  int minimo;
  Object aux;
  int i,j,num1;
        //Convertimos la LinkedList de todas las cuentas del banco a un Array
  CuentasArray = (b.listadoCuentas()).toArray();

  //Inicio para ordenar el Saldo
  
  //Mostrar las cuentas sin ordenar:
  System.out.println("-------------Cuentas Sin Ordenar --------------");
  for(num1=0; num1<CuentasArray.length; num1++){
    System.out.println(((Cuenta)CuentasArray[num1]).getSaldo());
  }

  //algorismo de ordenacin por Seleccin Directa:
  for(i=0;i<CuentasArray.length-1;i++){
    minimo = i;
    for(j=i+1;j<CuentasArray.length;j++){
      if (((Cuenta)CuentasArray[j]).getSaldo() < ((Cuenta)CuentasArray[minimo]).getSaldo()){
        minimo=j;
      }
    }
    //intercambio entre CuentasArray[i] y CuentasArray[minimo] 
    aux = CuentasArray[i];
    CuentasArray[i] = CuentasArray[minimo];
    CuentasArray[minimo] = aux;    
  }
  
  //Mostrar las cuentas ya ordenadas:
  System.out.println("--------------Cuentas Ordenadas por Saldo --------");
  for(num1=0; num1<CuentasArray.length; num1++){
    System.out.println(((Cuenta)CuentasArray[num1]).getSaldo());
  }
  
  //fin para el Saldo
  
  
  //inicio para ordenar por Titular (apellidos):
  
  //Mostrar las cuentas sin ordenar:
  System.out.println("--------------Cuentas No Ordenadas --------------");
  for(num1=0; num1<CuentasArray.length; num1++){
    System.out.println((((Cuenta)CuentasArray[num1]).getTitular()).getApellidos() + ", " +(((Cuenta)CuentasArray[num1]).getTitular()).getNombre());
  }
  
  //algorismo de ordenacin por Seleccin Directa:
  for(i=0;i<CuentasArray.length-1;i++){
    minimo = i;
    for(j=i+1;j<CuentasArray.length;j++){
      
      if ((((((Cuenta)CuentasArray[j]).getTitular()).getApellidos()).compareTo((((Cuenta)CuentasArray[minimo]).getTitular()).getApellidos())) < 0) {
        minimo=j;
      }
    }
    //intercambio entre CuentasArray[i] y CuentasArray[minimo]
    aux = CuentasArray[i];
    CuentasArray[i] = CuentasArray[minimo];
    CuentasArray[minimo] = aux;    
  }
  
  //Mostrar las cuentas ya ordenadas:
  System.out.println("--------------Cuentas Ordenadas por Titular ---------");
  for(num1=0; num1<CuentasArray.length; num1++){
    System.out.println((((Cuenta)CuentasArray[num1]).getTitular()).getApellidos() + ", " +(((Cuenta)CuentasArray[num1]).getTitular()).getNombre());
  }
  
  //fin para ordenar por Titular
  
  
}
  
	 }
